import { QueryBuilder } from '@syncfusion/ej2-querybuilder';
import { ComponentBase, EJComponentDecorator, allVue, getProps, gh } from '@syncfusion/ej2-vue-base';
import { Vue } from 'vue-class-component';
import Vue$1 from 'vue';
import { getValue, isNullOrUndefined } from '@syncfusion/ej2-base';

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const isExecute = gh ? false : true;
let vueImport;
if (!isExecute || parseInt(allVue.version) < 3) {
    vueImport = Vue;
}
else {
    vueImport = Vue$1;
}
let ColumnsDirective = class ColumnsDirective extends vueImport {
    render() {
        return;
    }
    getTag() {
        return 'e-columns';
    }
};
ColumnsDirective = __decorate([
    EJComponentDecorator({}, isExecute)
], ColumnsDirective);
const ColumnsPlugin = {
    name: 'e-columns',
    install(Vue$$1) {
        Vue$$1.component(ColumnsPlugin.name, ColumnsDirective);
    }
};
/**
 * `e-column` directive represent a column of the VueJS QueryBuilder.
 * It must be contained in a QueryBuilder component(`ejs-querybuilder`).
 * ```vue
 * <ejs-querybuilder :dataSource='data'>
 *   <e-columns>
 *    <e-column field='ID' label='ID' type='number'/>
 *    <e-column field='Date' label='Date' type='date' format='dd/MM/yyyy'/>
 *   </e-columns>
 * </ejs-querybuilder>
 * ```
 */
let ColumnDirective = class ColumnDirective extends vueImport {
    render() {
        return;
    }
    getTag() {
        return 'e-column';
    }
};
ColumnDirective = __decorate([
    EJComponentDecorator({}, isExecute)
], ColumnDirective);
const ColumnPlugin = {
    name: 'e-column',
    install(Vue$$1) {
        Vue$$1.component(ColumnPlugin.name, ColumnDirective);
    }
};

var __decorate$1 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
// {{VueImport}}
const properties = ['islazyUpdate', 'allowValidation', 'columns', 'cssClass', 'dataSource', 'displayMode', 'enableNotCondition', 'enablePersistence', 'enableRtl', 'fieldMode', 'fieldModel', 'headerTemplate', 'height', 'immediateModeDelay', 'locale', 'matchCase', 'maxGroupCount', 'operatorModel', 'readonly', 'rule', 'separator', 'showButtons', 'sortDirection', 'summaryView', 'valueModel', 'width', 'actionBegin', 'beforeChange', 'change', 'created', 'dataBound', 'ruleChange'];
const modelProps = [];
const testProp = getProps({ props: properties });
const props = testProp[0];
const watch = testProp[1];
const emitProbs = Object.keys(watch);
emitProbs.push('modelchanged');
for (let props of modelProps) {
    emitProbs.push('update:' + props);
}
const isExecute$1 = gh ? false : true;
/**
 * Represents the VueJS QueryBuilder Component.
 * ```html
 * <ejs-querybuilder></ejs-querybuilder>
 * ```
 */
let QueryBuilderComponent = 
/* Start Options({
    props: props,
    watch: watch,
    emits: emitProbs
}) End */
class QueryBuilderComponent extends ComponentBase {
    constructor() {
        super(arguments);
        this.propKeys = properties;
        this.models = modelProps;
        this.hasChildDirective = true;
        this.hasInjectedModules = false;
        this.tagMapper = { "e-columns": "e-column" };
        this.tagNameMapper = {};
        this.isVue3 = !isExecute$1;
        this.ej2Instances = new QueryBuilder({});
        this.bindProperties();
        this.ej2Instances._setProperties = this.ej2Instances.setProperties;
        this.ej2Instances.setProperties = this.setProperties;
        this.ej2Instances.clearTemplate = this.clearTemplate;
    }
    clearTemplate(templateNames) {
        if (!templateNames) {
            templateNames = Object.keys(this.templateCollection || {});
        }
        if (templateNames.length && this.templateCollection) {
            for (let tempName of templateNames) {
                let elementCollection = this.templateCollection[tempName];
                if (elementCollection && elementCollection.length) {
                    for (let ele of elementCollection) {
                        let destroy = getValue('__vue__.$destroy', ele);
                        if (destroy) {
                            ele.__vue__.$destroy();
                        }
                        if (ele.innerHTML) {
                            ele.innerHTML = '';
                        }
                    }
                    delete this.templateCollection[tempName];
                }
            }
        }
    }
    setProperties(prop, muteOnChange) {
        if (this.isVue3) {
            this.models = !this.models ? this.ej2Instances.referModels : this.models;
        }
        if (this.ej2Instances && this.ej2Instances._setProperties) {
            this.ej2Instances._setProperties(prop, muteOnChange);
        }
        if (prop && this.models && this.models.length) {
            Object.keys(prop).map((key) => {
                this.models.map((model) => {
                    if ((key === model) && !(/datasource/i.test(key))) {
                        if (this.isVue3) {
                            this.ej2Instances.vueInstance.$emit('update:' + key, prop[key]);
                        }
                        else {
                            this.$emit('update:' + key, prop[key]);
                            this.$emit('modelchanged', prop[key]);
                        }
                    }
                });
            });
        }
    }
    render(createElement) {
        let h = gh || createElement;
        let slots = null;
        if (!isNullOrUndefined(this.$slots.default)) {
            slots = gh ? this.$slots.default() : this.$slots.default;
        }
        return h('div', slots);
    }
    addGroups(groups, groupID) {
        return this.ej2Instances.addGroups(groups, groupID);
    }
    addRules(rule, groupID) {
        return this.ej2Instances.addRules(rule, groupID);
    }
    deleteGroup(target) {
        return this.ej2Instances.deleteGroup(target);
    }
    deleteGroups(groupIdColl) {
        return this.ej2Instances.deleteGroups(groupIdColl);
    }
    deleteRules(ruleIdColl) {
        return this.ej2Instances.deleteRules(ruleIdColl);
    }
    getDataManagerQuery(rule) {
        return this.ej2Instances.getDataManagerQuery(rule);
    }
    getFilteredRecords() {
        return this.ej2Instances.getFilteredRecords();
    }
    getGroup(target) {
        return this.ej2Instances.getGroup(target);
    }
    getOperators(field) {
        return this.ej2Instances.getOperators(field);
    }
    getPredicate(rule) {
        return this.ej2Instances.getPredicate(rule);
    }
    getRule(elem) {
        return this.ej2Instances.getRule(elem);
    }
    getRules() {
        return this.ej2Instances.getRules();
    }
    getRulesFromSql(sqlString) {
        return this.ej2Instances.getRulesFromSql(sqlString);
    }
    getSqlFromRules(rule, allowEscape) {
        return this.ej2Instances.getSqlFromRules(rule, allowEscape);
    }
    getValidRules(currentRule) {
        return this.ej2Instances.getValidRules(currentRule);
    }
    getValues(field) {
        return this.ej2Instances.getValues(field);
    }
    notifyChange(value, element, type) {
        return this.ej2Instances.notifyChange(value, element, type);
    }
    reset() {
        return this.ej2Instances.reset();
    }
    setRules(rule) {
        return this.ej2Instances.setRules(rule);
    }
    setRulesFromSql(sqlString) {
        return this.ej2Instances.setRulesFromSql(sqlString);
    }
    validateFields() {
        return this.ej2Instances.validateFields();
    }
};
QueryBuilderComponent = __decorate$1([
    EJComponentDecorator({
        props: properties
    }, isExecute$1)
    /* Start Options({
        props: props,
        watch: watch,
        emits: emitProbs
    }) End */
], QueryBuilderComponent);
const QueryBuilderPlugin = {
    name: 'ejs-querybuilder',
    install(Vue$$1) {
        Vue$$1.component(QueryBuilderPlugin.name, QueryBuilderComponent);
        Vue$$1.component(ColumnPlugin.name, ColumnDirective);
        Vue$$1.component(ColumnsPlugin.name, ColumnsDirective);
    }
};

export { ColumnsDirective, ColumnDirective, ColumnsPlugin, ColumnPlugin, QueryBuilderComponent, QueryBuilderPlugin };
export * from '@syncfusion/ej2-querybuilder';
//# sourceMappingURL=ej2-vue-querybuilder.es2015.js.map
